;----------------------------------------------------------------
; sys_boot.asm
;
; (c) Texas Instruments 2011, All rights reserved.
;

;****************************************************************
;*       UNDEFINED REFERENCES                               	*
;****************************************************************
 	.global _init
  	.global _systemInit
  	.global main

;****************************************************************
;*      Globals							*
;****************************************************************
	.global _c_int00
	.global _Stack_Table_Pointer
	.global _memoryInit_
	.global _memoryTest_
	.global _lbistTest_
	.global NVIC_enable
    .global _set_ecp_clk
	
;****************************************************************
mainSp: .word _Stack_Table_Pointer


	.text
;---------------------------------------------------------------
_c_int00:

    	; .mmsg  "Cortex M3 boot-up"

     	;*------------------------------------------------------
	; Initialize the Stack Pointer 
     	;*------------------------------------------------------
        ldr   r0, mainSp
        msr   msp, r0


     	;*------------------------------------------------------
	; Device Initialisation
     	;*------------------------------------------------------
     	bl    _systemInit



        .if 0

        bl _set_ecp_clk

        .endif 


     	;*------------------------------------------------------
	;* Run CPU tests 
     	;*------------------------------------------------------
	.if 0
    	
	bl   _lbistTest_

	.endif


     	;*------------------------------------------------------
	;* Run memory tests
     	;*------------------------------------------------------
	.if 0

    	bl   _memoryTest_

	.endif


     	;*------------------------------------------------------
	;* Initialize memory 	
     	;*------------------------------------------------------
    	bl   _memoryInit_


     	;*------------------------------------------------------
    	;* PERFORM AUTO-INITIALIZATION  
     	;*------------------------------------------------------
     	bl    _init


     	;*------------------------------------------------------
    	;* Enable Interrupt handling 
     	;*------------------------------------------------------
	.if 1

     	bl    NVIC_enable

	.endif
	

     	;*------------------------------------------------------	
	; To main()
     	;*------------------------------------------------------
_c1_:   bl  main


     	;*------------------------------------------------------
     	;* LOOP HERE FOREVER
     	;*------------------------------------------------------
L1:  	b   L1


	.end
;--------------------------------------------------------------



