/* (c) Texas Instruments 2012, All rights reserved. */

/** @mainpage TMS470MF066 Micro Controller Driver Documentation
*   @date 15.January.2012
*
*/

#include "system.h"

/* USER CODE BEGIN (0) */
/* USER CODE END */


/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (1) */
#include "het.h"
/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (2) */
    uint32_t i;
    hetInit();
    pwmEnableNotification(pwm0, pwmEND_OF_DUTY);

    NVIC_enable();
    _enable_interrupts();

    pwmStart(pwm0);

    for(i=0;i<500000;i++);

    pwmDisableNotification(pwm0, pwmEND_OF_DUTY);
    while(1);
/* USER CODE END */

}


/* USER CODE BEGIN (3) */
void pwmDisableNotification(unsigned pwm, unsigned notification)
{

    if(pwmEND_OF_PERIOD == notification)
    {
        hetRAM->Instruction[(pwm << 1U) + 42U].Control  &= 0xfffffffeU;     /* disable interrupt in the control field of the instruction */
    }
    else if(pwmEND_OF_DUTY == notification)
    {
        hetRAM->Instruction[(pwm << 1U) + 41U].Control  &= 0xfffffffeU;     /* disable interrupt in the control field of the instruction */
    }
    else
    {
        hetRAM->Instruction[(pwm << 1U) + 42U].Control  &= 0xfffffffeU;     /* disable interrupt in the control field of the instruction */
        hetRAM->Instruction[(pwm << 1U) + 41U].Control  &= 0xfffffffeU;     /* disable interrupt in the control field of the instruction */
    }

    hetREG->FLG     = notification << (pwm << 1U);
}

void esmGroup1Notification(uint32_t channel)
{

}


/** @fn void esmGroup2Notification(uint32_t channel)
*   @brief Interrupt callback
*   @param[in] channel - Group 2 channel
*
* This is a callback that is provided by the application and is called upon
* an interrupt. The parameter passed to the callback is group 2 channel caused the interrupt.
*/
void esmGroup2Notification(uint32_t channel)
{

}

void pwmNotification(unsigned pwm, unsigned notification)
{

}

void edgeNotification(unsigned edge)
{

}

/* USER CODE END */
