;-------------------------------------------------------------------------------
; sys_memory.asm
;
; (c) Texas Instruments 2011, All rights reserved.
;

    .text
    
    .if 0
;-------------------------------------------------------------------------------
; Run Memory Test

    .global     _memoryTest_
    .global     memoryTestFailNotification ; refer sys_memory.h for the notification function
    .asmfunc

_memoryTest_

        ldr   r12, regMstGcr     ; Memory Hardware Initialization Global Control Register pointer 
        ldr   r11, regMsiEna     ; MBIST Controller/Memory Initialization Enable Register pointer
        ldr   r10, regMstFail    ; Memory Self-Test Fail Status Register pointer
        ldr   r9,  regMstCgstat  ; MSTC Global Status Register pointer 

	; Get configaration for regMsiEna
	ldr   r8, mchnconf
        mov   r5,#16
        mov   r6,#0

l1          
	subs  r5,r5,#1
	beq   MsiEna
        ldr   r7,[r8],#4
        orr   r6,r7
        b     l1
MsiEna
        str   r6, [r11]          ; Select Memory Channels for BIST


	; Get configaration for regMstGcr
	ldr   r8,  mconfig       
        mov   r5,#9
        mov   r6,#0
l2        
	subs  r5,r5,#1
	beq   MstGcr
        ldr   r7,[r8],#4
        orr   r6,r7
        b     l2

MstGcr

        str   r6, [r12]          ; Configure Algo, Rom_Clk div and enable MBIST


        nop 	  	         ; wait for 32 VBUS cycles ( Hard coded ROM DIV = 1)
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop

dloop  
        ldr   r8, [r9] 		; Wait till MBIST completes
        cmp   r8, #0
        beq   dloop 

        ldr   r0, [r10] 	; Check for Memory self test fail status
        cmp   r0, #0

        beq   mbistEnd
        bl    memoryTestFailNotification

mbistEnd
        mov   r8, #5
        str   r8, [r12]         ; Disable Pbist and ROM slock in PACT register
        bx    lr

memoryTestFailNotification
        b   memoryTestFailNotification



regMstGcr     .word 0xFFFFFF58
regMsiEna     .word 0xFFFFFF60
regMstFail    .word 0xFFFFFF64
regMstCgstat  .word 0xFFFFFF68

;----------------------------------------------------------------------
gcr_config
              .field 0x010A<<0

	      .field 1<<16
              .field 1<<17
              .field 1<<18
              .field 1<<19
              .field 1<<20
              .field 0<<21
              .field 0<<22
              .field 0<<23


mconfig       .word gcr_config



;----------------------------------------------------------------------
mchnselect
	      	.field 1<<0
	      	.field 1<<1
	      	.field 0<<2
          	.field 1<<3
          	.field 0<<4
          	.field 1<<5
          	.field 1<<6
          	.field 0<<7
          	.field 0<<8
	      	.field 0<<9
	      	.field 0<<10
	      	.field 0<<11
	      	.field 0<<12
	      	.field 0<<13
	      	.field 0<<14
	      	.field 0<<15



mchnconf      .word mchnselect



    .endasmfunc

 .endif

;-------------------------------------------------------------------------------
; Initialize memory

    .def     _memoryInit_
    .asmfunc

_memoryInit_
        
        ldr   r12, regMinitGcr    ; MINITGCR register pointer 
        mov   r4, #0xA
        str   r4, [r12]
        ldr   r4, ramInitMask     ; load RAM initialization mask
        str   r4, [r12, #4]
mloop
        ldr   r5, [r12, #12]
        tst   r5, #0x100
        beq   mloop
        mov   r4, #5
        str   r4, [r12]
        bx    lr
    
ramInitMask   .word 0x0039
regMinitGcr   .word 0xFFFFFF5C

    .endasmfunc


;-------------------------------------------------------------------------------

